/****************************************************************************
**
** Trolltech hereby grants a license to use the Qt/Eclipse Integration
** plug-in (the software contained herein), in binary form, solely for the
** purpose of creating code to be used with Trolltech's Qt software.
**
** Qt Designer is licensed under the terms of the GNU General Public
** License versions 2.0 and 3.0 ("GPL License"). Trolltech offers users the
** right to use certain no GPL licensed software under the terms of its GPL
** Exception version 1.2 (http://trolltech.com/products/qt/gplexception).
**
** THIS SOFTWARE IS PROVIDED BY TROLLTECH AND ITS CONTRIBUTORS (IF ANY) "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
** TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
** PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
** OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
** EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
** PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
** PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
** LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
** NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
** SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE."
**
** Since we now have the GPL exception I think that the "special exception
** is no longer needed. The license text proposed above (other than the
** special exception portion of it) is the BSD license and we have added
** the BSD license as a permissible license under the exception.
**
****************************************************************************/

#include "HelpDialog.h"

HelpDialog::HelpDialog(QString helpPath, QWidget *parent)
    : QDialog(parent),
      m_helpIni(helpPath, QSettings::IniFormat)
{
	ui.setupUi(this);
	initHelpContent();
	
	connect (ui.problemsList, SIGNAL(currentItemChanged ( QListWidgetItem *, QListWidgetItem * )), this, SLOT(currentItemChanged ( QListWidgetItem *, QListWidgetItem * )));
}

HelpDialog::~HelpDialog()
{

}

void HelpDialog::initHelpContent()
{
	if ( !m_helpIni.value("file_ok", false).toBool() )
	{
		ui.solutionBrowser->setText( tr("<center>Failed to load help file!") );
		return;
	}
	
	QRegExp helpRegExp("^Item_[0-9]{1,3}$");
	
	foreach (QString group, m_helpIni.childGroups().filter(helpRegExp))
	{
		m_helpIni.beginGroup(group);
		
		QString problem = m_helpIni.value("problem").toString();
		QString solution = m_helpIni.value("solution").toString();
		
		if ( problem.isEmpty() || solution.isEmpty() )
		{
			m_helpIni.endGroup();
			continue;
		}
		
		QListWidgetItem *item1 = new QListWidgetItem(tr("No modem synchronization"), ui.problemsList);
	}
	
	QListWidgetItem *item1 = new QListWidgetItem(tr("No modem synchronization"), ui.problemsList);
	
	QString sloution1 = tr("");
	
	item1->setData(Qt::UserRole, sloution1);
	
	/* --------------------- */
	
	QListWidgetItem *item2 = new QListWidgetItem(tr("No modem synchronization 2"), ui.problemsList);
	
	QString sloution2 = "...................... 2";
	
	item2->setData(Qt::UserRole, sloution2);
}

void HelpDialog::currentItemChanged ( QListWidgetItem * current, QListWidgetItem * )
{
	if ( current == 0 )
		return;
	
	ui.solutionBrowser->setText( current->data(Qt::UserRole).toString() );
}
