#ifndef SETTINGS_H
#define SETTINGS_H

#include <QtGui/QDialog>
#include "ui_Settings.h"

class Settings : public QDialog
{
    Q_OBJECT

public:
    Settings(QWidget *parent = 0);
    ~Settings();
    
    bool getAccountDataChanged();
    bool getConnectAtBootChanged();
    bool getConnectAtModemPlugChanged();
    bool getIdleTimeChanged();
    bool getIdleChanged();
	void getData();

    Ui::SettingsClass ui;
	
public slots:
    void show() { getData(); QDialog::show(); }
    
private slots:
	void dataChanged();
	
private:
	QString m_login;
	QString m_password;
	int     m_idle;
	bool    m_idleChecked;
	bool    m_connectAtBoot;
	bool    m_connectAtModemPlug;
};

#endif // SETTINGS_H
