#include "Applet.h"
#include "HelpDialog.h"

#include <QtGui>
#include <QApplication>

int main(int argc, char *argv[])
{
//     if ( QApplication::setStyle("oxygen") == 0 )
    QApplication::setStyle(new CustomStyle());

    QApplication app(argc, argv);
    
#if QT_VERSION >= 0x040400
    app.setApplicationName("UbuDSL Applet");
    app.setApplicationVersion("1.0.0");
#endif
    
    QString translatorFileName = QLatin1String("UbuDSL_Applet_");
    translatorFileName += QLocale::system().name();

    QTranslator *translator = new QTranslator(&app);

    if (!translator->load(translatorFileName, QString(app.applicationDirPath() + "/../translations/")))
    {
        qDebug() << "Failed to load the" << QString(app.applicationDirPath() + "/../translations/" + translatorFileName + "!");

        if (!translator->load(QString(":translations/" + translatorFileName)))
        {
            qDebug() << "Failed to load the" << QString(":translations/" + translatorFileName + "!");
        }
    }
    
    app.installTranslator(translator);
//    app.setStyle(new CustomStyle);

    QSettings palette( ":palette.ini", QSettings::IniFormat );
    app.setPalette( palette.value("palette").value<QPalette>() );

//    HelpDialog d;
//    d.show();
    
    Applet w;
    w.show();

    
    app.connect(&app, SIGNAL(lastWindowClosed()), &app, SLOT(quit()));
    app.connect(&w, SIGNAL(quit()), &app, SLOT(quit()));
    
    return app.exec();
}
