#ifndef GENERATORTHREAD_H_
#define GENERATORTHREAD_H_

#include <QThread>
#include <QString>
#include <QProcess>
#include <QNetworkInterface>
#include <QNetworkAddressEntry>
#include <QHostAddress>
#include <QList>
#include <QListIterator>
#include <QFile>
#include <QFileInfo>
#include <QStringList>
#include <QDir>
#include <QRegExp>

#include "libubudsl/libubudsl.h"
#include <sys/klog.h>

class GeneratorThread: public QThread
{
	Q_OBJECT
public:
	GeneratorThread();
	virtual ~GeneratorThread();

	void setGatheredInfo(const QString &gatheredInfo);
	QString getLogFilePath() { return QDir::homePath() + "/ubudsl_log.tbz2"; }
public slots:
	void run();
private:
	void getIfaces();
	void getUSBDevices();
	void getDNSServers();
	void getSystemInfo();
	void getFirmwareInfo();
	void getRoutingTable();
	void getPermissions();
	void removeLogDirContent();
	void getKernelMessages();
	
	QFile *logFile;
	QFile *kernelMsgs;
	QDir  *ubudslLogDir;
	QString m_gatheredInfo;
signals:
	void writingFailed();
};

#endif /*GENERATORTHREAD_H_*/
