#include "LogGenerator.h"

#include <QtGui>
#include <QApplication>
#include <QTranslator>
#include <QLocale>
#include <QLibraryInfo>

int main(int argc, char *argv[])
{
    QApplication app(argc, argv);
    
    QString translatorFileName = QLatin1String("LogGenerator_");
    translatorFileName += QLocale::system().name();

    QTranslator *translator = new QTranslator(&app);

    if (!translator->load(translatorFileName, QString(app.applicationDirPath() + "/../translations/")))
    {
        qDebug() << "Failed to load the" << QString(app.applicationDirPath() + "/../translations/" + translatorFileName + "!");

        if (!translator->load(translatorFileName, QString(app.applicationDirPath() + "/translations/")))
        {
            qDebug() << "Failed to load the" << QString(app.applicationDirPath() + "/translations/" + translatorFileName + "!");

            if (!translator->load(QString(":translations/" + translatorFileName)))
            {
                qDebug() << "Failed to load the" << QString(":translations/" + translatorFileName + "!");
            }
        }
    }

    app.installTranslator(translator);
    
    
    LogGenerator logGenerator;
    logGenerator.show();

    return app.exec();
}
