/*
 * File: ScriptManager.cpp
 * Created: Sun 27 Jan 2008
 * Last modified: Wed 23 Apr 2008
 * Author: Adrian Łubik
 * License: GNU LGPL v3 or newer
 */

#include "ScriptManager.h"


ScriptManager::ScriptManager()
        : m_scriptFile ( new QFile() )
{
// parser = new Parser;
// parser->setFile( xmlFilePath );
// parser->setGroup( "script_manager" );

    // const QString sys = UbuDSL::SystemInfo::getDistributionName();
    // const QString ver = UbuDSL::SystemInfo::getDistributionRelease();

    //    m_scriptFile       = new QFile();
    //    autostartScript   = parser->getValue( sys, ver, "autostart_script"    ).toString();
    //    pppScript         = parser->getValue( sys, ver, "ubudsl_peer_script"  ).toString();
    //    papSecretsScript  = parser->getValue( sys, ver, "pap_secrets"         ).toString();
    //    chapSecretsScript = parser->getValue( sys, ver, "chap_secrets"        ).toString();
    //    unicornScript     = parser->getValue( sys, ver, "unicorn_peer_script" ).toString();
    //    optionsScript     = parser->getValue( sys, ver, "ppp_options"         ).toString();

    autostartScript   = "/etc/init.d/ubudsld";
    pppScript         = "/etc/ppp/peers/ubudsl";
    papSecretsScript  = "/etc/ppp/pap-secrets";
    chapSecretsScript = "/etc/ppp/chap-secrets";
    unicornScript     = "/etc/ppp/peers/ubudsl_unicorn";
    optionsScript     = "/etc/ppp/options";

    qDebug() << "autostartScript:"   << autostartScript  << "\npppScript"         << pppScript
    << "\npapSecretsScript" << papSecretsScript << "\nchapSecretsScript" << chapSecretsScript
    << "\nunicornScript"    << unicornScript    << "\noptionsScript"     << optionsScript;
}


ScriptManager::~ScriptManager()
{
    qDebug() << "~ScriptManager()";
    delete m_scriptFile;
}


void ScriptManager::setScriptsPermissions()
{
	QFile::setPermissions( "/etc/ppp/options",      QFile::ReadUser );
	QFile::setPermissions( "/etc/ppp/pap-secrets",  QFile::ReadUser );
	QFile::setPermissions( "/etc/ppp/chap-secrets", QFile::ReadUser );
	QFile::setPermissions( "/etc/ppp/peers/ubudsl", QFile::ReadUser|QFile::ReadGroup|QFile::ReadOther );
	QFile::setPermissions( "/etc/init.d/ubudsld",   QFile::ReadUser|QFile::WriteUser|
			                                        QFile::ExeUser |QFile::ReadGroup|
			                                        QFile::ExeGroup|QFile::ExeOther );
	
	QFile::setPermissions( "/etc/ppp/peers/ubudsl_unicorn", QFile::ReadUser|QFile::ReadGroup|
			                                                QFile::ReadOther );
}


/*bool ScriptManager::writeAutostartScript()
{
    m_scriptFile->setFileName ( autostartScript );

    if ( m_scriptFile->open ( QFile::WriteOnly | QFile::Truncate ) )
    {
        m_scriptFile->write ( "#!/bin/sh -e\n" );
        m_scriptFile->write ( "#\n" );
        m_scriptFile->write ( "#   /etc/init.d/ubudsld: UbuDSL daemon.\n\n" );

        m_scriptFile->write ( "test -x /usr/sbin/ubudsldaemon || exit 0\n" );
        m_scriptFile->write ( ". /lib/lsb/init-functions\n\n" );

        m_scriptFile->write ( "case \"$1\" in\n" );
        m_scriptFile->write ( "start)\n" );
        m_scriptFile->write ( "    log_begin_msg \"Starting UbuDSL daemon...\"\n" );

        m_scriptFile->write ( "    /etc/init.d/hal start\n" );
        m_scriptFile->write ( "    start-stop-daemon --start --quiet --exec /usr/sbin/ubudsldaemon&\n" );
        m_scriptFile->write ( "    log_end_msg $?\n" );
        m_scriptFile->write ( "    ;;\n" );
        m_scriptFile->write ( "stop)\n" );
        m_scriptFile->write ( "    log_begin_msg \"Stopping UbuDSL daemon...\"\n" );
        m_scriptFile->write ( "    start-stop-daemon --stop --quiet --oknodo --retry 2 --exec /usr/sbin/ubudsldaemon\n" );
        m_scriptFile->write ( "    log_end_msg $?\n" );
        m_scriptFile->write ( "    ;;\n" );
        m_scriptFile->write ( "restart|force-reload)\n" );
        m_scriptFile->write ( "    log_begin_msg \"Reloading UbuDSL daemon...\"\n" );
        m_scriptFile->write ( "    start-stop-daemon --stop --signal 1 --exec /usr/sbin/ubudsldaemon&\n" );
        m_scriptFile->write ( "    log_end_msg $?\n" );
        m_scriptFile->write ( "    ;;\n" );
        m_scriptFile->write ( "*)\n" );
        m_scriptFile->write ( "    log_success_msg \"Usage: /etc/init.d/ubudsld {start|stop|restart}\"\n" );
        m_scriptFile->write ( "    exit 1\n" );
        m_scriptFile->write ( "    ;;\n" );
        m_scriptFile->write ( "esac\n\n" );

        m_scriptFile->write ( "exit 0\n\n" );


        m_scriptFile->close();
        return true;
    }
    else
    {
        return false;
    }
}*/


bool ScriptManager::writeOptionsScript()
{
    m_scriptFile->setFileName ( optionsScript );
    qDebug() << "ScriptManager::writeOptionsScript(): fileName:" << m_scriptFile->fileName();

    if ( m_scriptFile->open ( QFile::WriteOnly | QFile::Truncate ) )
    {
        m_scriptFile->write ( "replacedefaultroute\n" );
        m_scriptFile->write ( "updetach\n" );

        m_scriptFile->close();
        return true;
    }
    else
    {
        return false;
    }
}


bool ScriptManager::writePPPoAScript ( const unsigned short &VPI,
                                       const unsigned short &VCI,
                                       const QString &serviceLogin )
{
    m_scriptFile->setFileName ( pppScript );
    qDebug() << "ScriptManager::writePPPoAScript(): fileName:" << m_scriptFile->fileName();

    if ( m_scriptFile->open ( QFile::WriteOnly | QFile::Truncate ) )
    {
    	m_scriptFile->write ( "lock\n" );
        m_scriptFile->write ( "noipdefault\n" );
        m_scriptFile->write ( "defaultroute\n" );
        m_scriptFile->write ( "hide-password\n" );
        m_scriptFile->write ( "lcp-echo-interval 20\n" );
        m_scriptFile->write ( "lcp-echo-failure 3\n" );
        m_scriptFile->write ( "connect /bin/true\n" );
        m_scriptFile->write ( "noauth\n" );
        m_scriptFile->write ( "persist\n" );
        m_scriptFile->write ( "mtu 1492\n" );
        m_scriptFile->write ( "noaccomp\n" );
        m_scriptFile->write ( "holdoff 4\n" );
        m_scriptFile->write ( "default-asyncmap\n" );
        m_scriptFile->write ( QString ( "plugin pppoatm.so %1.%2\n" ).arg ( VPI )
                              .arg ( VCI ).toStdString().c_str() );
        m_scriptFile->write ( QString ( "user \"%1\"\n" ).arg ( serviceLogin )   .toStdString().c_str() );

        m_scriptFile->close();
        return true;
    }
    else
    {
        return false;
    }
}


bool ScriptManager::writePPPoEScript ( const QString &serviceLogin )
{
    m_scriptFile->setFileName ( pppScript );
    qDebug() << "ScriptManager::writePPPoEScript(): fileName:" << m_scriptFile->fileName();

    if ( m_scriptFile->open ( QFile::WriteOnly | QFile::Truncate ) )
    {
        m_scriptFile->write ( "lock\n" );
        m_scriptFile->write ( "noipdefault\n" );
        m_scriptFile->write ( "defaultroute\n" );
        m_scriptFile->write ( "hide-password\n" );
        m_scriptFile->write ( "lcp-echo-interval 20\n" );
        m_scriptFile->write ( "lcp-echo-failure 3\n" );
        m_scriptFile->write ( "connect /bin/true\n" );
        m_scriptFile->write ( "noauth\n" );
        m_scriptFile->write ( "persist\n" );
        m_scriptFile->write ( "mtu 1492\n" );
        m_scriptFile->write ( "noaccomp\n" );
        m_scriptFile->write ( "default-asyncmap\n" );
        m_scriptFile->write ( "noaccomp\n" );
        m_scriptFile->write ( "holdoff 4\n" );
        m_scriptFile->write ( "plugin rp-pppoe.so\n" );
        m_scriptFile->write ( "nic-nas0\n" );
        m_scriptFile->write ( QString ( "user \"%1\"\n" ).arg ( serviceLogin ).toStdString().c_str() );

        m_scriptFile->close();
        return true;
    }
    else
    {
        return false;
    }
}


bool ScriptManager::writeSecretScripts ( const QString &serviceLogin, const QString &servicePassword )
{
    bool ok = true;

    m_scriptFile->setFileName ( papSecretsScript );
    qDebug() << "ScriptManager::writeSecretsScript(): fileName:" << m_scriptFile->fileName();

    if ( m_scriptFile->open ( QFile::WriteOnly | QFile::Truncate ) )
    {
        m_scriptFile->write ( QString ( "\"%1\" * \"%2\" *\n" ).arg ( serviceLogin ).arg ( servicePassword ).toStdString().c_str() );

        m_scriptFile->close();
        ok = true;
    }
    else
    {
        ok = false;
    }


    m_scriptFile->setFileName ( chapSecretsScript );
    qDebug() << "ScriptManager::writeSecretsScript(): fileName (2):" << m_scriptFile->fileName();

    if ( m_scriptFile->open ( QFile::WriteOnly | QFile::Truncate ) )
    {
        m_scriptFile->write ( QString ( "\"%1\" * \"%2\" *\n" ).arg ( serviceLogin ).arg ( servicePassword ).toStdString().c_str() );

        m_scriptFile->close();
        ok = true;
    }
    else
    {
        ok = false;
    }

    if ( ok )
        return true;
    else
        return false;
}


bool ScriptManager::writeUnicornScript ( const QString &serviceLogin )
{
    m_scriptFile->setFileName ( unicornScript );
    qDebug() << "ScriptManager::writeUnicornScript(): fileName:" << m_scriptFile->fileName();

    if ( m_scriptFile->open ( QFile::WriteOnly | QFile::Truncate ) )
    {
    	m_scriptFile->write ( "lock\n" );
        m_scriptFile->write ( "noipdefault\n" );
        m_scriptFile->write ( "defaultroute\n" );
        m_scriptFile->write ( "hide-password\n" );
        m_scriptFile->write ( "lcp-echo-interval 20\n" );
        m_scriptFile->write ( "lcp-echo-failure 3\n" );
        m_scriptFile->write ( "connect /bin/true\n" );
        m_scriptFile->write ( "noauth\n" );
        m_scriptFile->write ( "persist\n" );
        m_scriptFile->write ( "mtu 1492\n" );
        m_scriptFile->write ( "noaccomp\n" );
        m_scriptFile->write ( "default-asyncmap\n" );
        m_scriptFile->write ( "noaccomp\n" );
        m_scriptFile->write ( "holdoff 4\n" );
        m_scriptFile->write ( "plugin rp-pppoe.so\n" );
        m_scriptFile->write ( "nic-dsl0\n" );
        m_scriptFile->write ( QString ( "user \"%1\"\n" ).arg ( serviceLogin ).toStdString().c_str() );

        m_scriptFile->close();
        return true;
    }
    else
    {
        return false;
    }
}


void ScriptManager::replaceInFile ( const QString &fileName, const QString &sourceStr, const QString &destStr )
{
    QFile *file = new QFile ( fileName );

    if ( file->open ( QIODevice::ReadOnly ) )
    {
        //int indexOfBegin;
        //int indexOfEndl;

        QString content = file->readAll();

        file->close();

        while ( content.contains ( sourceStr ) )
        {
            /*            indexOfBegin = content.lastIndexOf(sourceStr);
                        indexOfEndl = content.indexOf('\n', indexOfBegin);
                        if ( indexOfBegin >= 0 && indexOfEndl >= 0)
                        {
                            content.remove( indexOfBegin, indexOfEndl );
                        }
            */
            content = content.replace ( sourceStr, destStr );
        }

        if ( file->open ( QFile::WriteOnly | QFile::Truncate ) )
        {
            QByteArray ba = QByteArray();
            ba.append ( content );
            //ba.append( destStr );
            ba.append ( "\n" );

            file->write ( ba );

            ba.clear();
            file->close();
        }
        else
        {
            qWarning() << "ScriptManager::replaceInFile(): couldn't open file" << fileName << "in write only mode!";
        }
    }
    else
    {
        qWarning() << "ScriptManager::replaceInFile(): couldn't open file" << fileName << "in read only mode!";
    }

    delete file;
}


void ScriptManager::removeFromFile ( const QString &fileName, const QString &lineToRemove )
{
    QFile *file = new QFile ( fileName );
    if ( file->open ( QIODevice::ReadOnly ) )
    {
        QString content = file->readAll();

        while ( content.contains ( lineToRemove + "\n" ) )
        {
            content = content.remove ( lineToRemove + "\n" );
        }

        file->close();

        if ( file->open ( QFile::ReadWrite | QFile::Truncate ) )
        {
            QByteArray ba = QByteArray();
            ba.append ( content );
            file->write ( ba );
            file->close();
        }
    }

    delete file;
}


void ScriptManager::writeToFile ( const QString &fileName, const QString &lineToWrite )
{
    QFile *file = new QFile ( fileName );

    if ( file->open ( QIODevice::ReadOnly ) )
    {
        QString content = file->readAll();

        if ( content.contains ( lineToWrite ) )
        {
            qDebug() << "ScriptManager::writeToFile(): There is already such line.";
            file->close();
            return;
        }

        file->close();

        content = content.append ( lineToWrite );
        content = content.append ( "\n" );

        if ( file->open ( QFile::WriteOnly | QFile::Truncate ) )
        {
            QByteArray ba = QByteArray();
            ba.append ( content );
            file->write ( ba );
            file->close();
        }
    }
    file->close();
}

void ScriptManager::writeUnicornOption( const QString &optionsFile, int &vpi, int &vci, int &protocol )
{
	printf("VPI: %i, VCI: %i\n", vpi, vci);
	QFile options( optionsFile );
	
	QByteArray toWrite;
	
	if ( options.open( QFile::ReadOnly ) )
	{
		while ( !options.atEnd() )
		{
			QByteArray line = options.readLine();
			if ( !line.startsWith("options unicorn_usb_eth") )
				toWrite.append(line);
		}
		
		options.close();
	}
	
	if ( !toWrite.isEmpty() && !toWrite.endsWith( '\n' ) )
		toWrite.append( '\n' );
	
	toWrite.append( "options unicorn_usb_eth ActivationMode=3 VPI=" );
	toWrite.append( QString::number(vpi) );
	toWrite.append( " VCI=" );
	toWrite.append( QString::number(vci) );
	
	if ( protocol == 0 )
	{
		toWrite.append( " PROTOCOL=pppoatm " );
		toWrite.append( "ENCAPS=vc-encaps\n" );
	}
	else
	{
		toWrite.append( " PROTOCOL=pppoe " );
		toWrite.append( "ENCAPS=llcc-encaps\n" );
	}
	
	
	if ( options.open( QFile::WriteOnly|QFile::Truncate ) )
	{
		options.write( toWrite );
		options.close();
	}
	else
	{
		qDebug() << "ScriptManager::writeUnicornOption(): failed to write options!";
	}
}

