/*
 * File: CustomStyle.cpp
 * Created: Tue 23 Apr 2008
 * Last modified: Tue 23 Apr 2008
 * Author: Adrian Łubik
 * License: GNU LGPL v3 or newer
 */

#include "CustomStyle.h"

CustomStyle::CustomStyle()
{
	
}

CustomStyle::~CustomStyle()
{
	
}

QPixmap CustomStyle::standardPixmap(StandardPixmap standardPixmap, const QStyleOption *opt,
                                        const QWidget *widget) const
{
	QPixmap pixmap;
	
	switch (standardPixmap)
	{
		case SP_MessageBoxInformation:
			if ( pixmap.load(":/images/information.png") )
				return pixmap;
			break;
		case SP_MessageBoxCritical:
			if ( pixmap.load(":/images/critical.png") )
				return pixmap;
			break;
		case SP_MessageBoxWarning:
			if ( pixmap.load(":/images/warning.png") )
				return pixmap;
			break;
		case SP_MessageBoxQuestion:
			if ( pixmap.load(":/images/question.png") )
				return pixmap;
			break;
		case SP_TitleBarCloseButton:
			if ( pixmap.load(":/images/close.png") )
				return pixmap;
			
		default:
			break;
	}
	
	return QWindowsStyle::standardPixmap(standardPixmap, opt, widget);
}
