/*
 * File: ListBar.h
 * Created: Mon 31 Mar 2008
 * Last modified: Tue 23 Apr 2008
 * Author: Adrian Łubik
 * License: GNU LGPL v3 or newer
 */

#ifndef LISTBAR_H_
#define LISTBAR_H_

#include <QPainter>
#include <QBrush>
#include <QRadialGradient>
#include <QLinearGradient>
#include <QLine>
#include <QRectF>
#include <QLabel>
#include <QString>

class ListBar: public QWidget
{
public:
    enum Type { Squared, RoundedTop, RoundedBottom };

    ListBar ( ListBar::Type t = Squared, QWidget *parent = 0 );
    virtual ~ListBar() {}

    void setGradient ( QColor c1, QColor c2 )
    {
        this->c1 = c1;
        this->c2 = c2;
        update();
    }
public slots:
    void setText ( const QString &t )
    {
        lbl->setText ( t );
    }
private:
    void paintEvent ( QPaintEvent *event );

    Type t;
    QLabel *lbl;
    QColor  c1;
    QColor  c2;
    qreal   op;
};

#endif /*LISTBAR_H_*/
