/*
 * File: ProgressBar.h
 * Created: Mon 31 Mar 2008
 * Last modified: Tue 23 Apr 2008
 * Author: Adrian Łubik
 * License: GNU LGPL v3 or newer
 */

#ifndef PROGRESSBAR_H_
#define PROGRESSBAR_H_

#include <QPainter>
#include <QString>
#include <QWidget>
#include <QTimer>
#include <QDebug>
#include <QRect>

class ProgressBar: public QWidget
{
    Q_OBJECT
public:
    ProgressBar ( QWidget *parent = 0 );
    ProgressBar ( const QString &text, QWidget *parent = 0 );
    virtual ~ProgressBar() {}

    void setText ( const QString &text )
    {
        m_text = text;
        update();
    }
public slots:
    void start();
    void stop();
protected:
    void paintEvent ( QPaintEvent *event );

    QTimer *timer;
    QString m_text;

    qreal op1;
    qreal op2;
    qreal op3;
    qreal op4;

    QRect rectOne;
    QRect rectTwo;
    QRect rectThree;
    QRect rectFour;
};

#endif /*PROGRESSBAR_H_*/
