/*
 * File: ProgressTable.cpp
 * Created: Mon 31 Mar 2008
 * Last modified: Tue 23 Apr 2008
 * Author: Adrian Łubik
 * License: GNU LGPL v3 or newer
 */

#include "ProgressTable.h"

ProgressTable::ProgressTable ( QWidget *parent )
        : QWidget ( parent )
{
    setMinimumSize ( 340, 230 );
    setMaximumSize ( 340, 230 );
    setVisible ( false );
}

void ProgressTable::paintEvent ( QPaintEvent * )
{
    QPainter painter ( this );
    painter.setRenderHint ( QPainter::Antialiasing, true );
    painter.setWindow ( 0, 0, 340, 230 );
    painter.setPen ( QColor ( 101, 101, 101 ) );

    QRect textRect ( 0, 10, 325, 220 );
    QRect transparency ( 0, 0, 325, 220 );

    QLinearGradient lg ( 0, 0, 0, 50 );
    lg.setColorAt ( 0.0, QColor ( 250, 248, 247 ) );
    //lg.setColorAt(0.8, QColor(248, 245, 244, 200));
    lg.setColorAt ( 1.0, QColor ( 250, 248, 247, 0 ) );

    QBrush brush ( lg );
    QFont font("Free Sans");
    font.insertSubstitutions("Free Sans", QStringList() << "Nimbus Sans L" << "Luxi Sans" << "Lucida Sans" << "Andale Sans");
    font.setItalic ( true );
    font.setPointSizeF ( 7.5 );

    painter.setFont ( font );
    painter.drawText ( textRect, Qt::AlignLeft, cache.join ( "\n" ) );

    painter.setPen ( Qt::NoPen );
    painter.setBrush ( brush );
    painter.drawRect ( transparency );
}
