/*
 * File: ProgressTable.h
 * Created: Mon 31 Mar 2008
 * Last modified: Tue 23 Apr 2008
 * Author: Adrian Łubik
 * License: GNU LGPL v3 or newer
 */

#ifndef PROGRESSTABLE_H_
#define PROGRESSTABLE_H_

#include <QPainter>
#include <QStringList>
#include <QString>
#include <QWidget>

class ProgressTable: public QWidget
{
    Q_OBJECT
public:
    ProgressTable ( QWidget *parent = 0 );
    virtual ~ProgressTable() {}
public slots:
    void addMessage ( const QString &msg )
    {
        if ( cache.count() >= 16 ) cache.removeAt ( 0 );
        cache << QString::fromUtf8 ( "⚫ " ) + msg;
        update();
    }
protected:
    void paintEvent ( QPaintEvent *event );
    QStringList cache;
};

#endif /*PROGRESSTABLE_H_*/
