/*
 * File: UbuDSL_Cmd.h
 * Created: Thu 07 Feb 2008
 * Last modified: Tue 23 Apr 2008
 * Author: Adrian Łubik
 * License: GNU GPL v3 or newer
 */

#ifndef UBUDSL_CMD
#define UBUDSL_CMD

#include "libubudsl/libubudsl.h"
#include "UbuDSL_Thread.h"
#include <QtCore>

class UbuDSL_Cmd: public QObject
{
    Q_OBJECT
public:
    UbuDSL_Cmd( const int lockedFD );
    ~UbuDSL_Cmd();

private:
    UbuDSL_Thread *thread;
    QList<Volume>  volumes;
    ServiceParser *sparser;
    QString        chosenCountry;
    QString        chosenService;
    QString        login;
    QString        password;
    int            vpi;
    int            vci;
    int            protocol;
    QString        enterLogin;
    QString        enterPassword;
    QString        emptyLogin;
    QString        emptyPassword;
    QString        m_service;
    QStringList    m_dnsServers;

    void consoleWriteLine ( const QString &line = "", bool hash = true );
    void consoleWrite ( const QString &data );
    QByteArray consoleReadLine ();
private slots:
    void printMessage ( const QString &message );
    void setVolumesList ();
    void chooseCountry ( const QMap<int, QString> &cMap );
    void chooseService ( const QMap<int, QString> &sMap );
    void setServiceData ( unsigned short &VPI, unsigned short &VCI, const QString  &protocol, const QStringList &dnsServers );
    void incompatibleArch();

    void wHash()
    {
        consoleWrite ( "# " );
    }
    void separator()
    {
        consoleWriteLine ( "#-----------------------------------------------------------------------#", false );
    }

signals:
    void volumeSelected ( const int index );
    void finished();
};

#endif
