#ifndef COMPILERTHREAD_H_
#define COMPILERTHREAD_H_

#include <QThread>
#include <QString>
#include <QList>
#include <QListIterator>

#include "libubudsl/libubudsl.h"

class UbuDSL_Daemon;

class CompilerThread: public QThread
{
	Q_OBJECT
public:
	enum Result
	{
		Success,
		CompilationFailed,
		InstallationFailed
	};
	
	CompilerThread( const UbuDSL_Daemon &, const QString &driverName = "", QObject *parent = 0 );
	virtual ~CompilerThread();
	
	void run();
	int  testDriver();
	void setDriverName( const QString &driverName );
	int  getResult();
	
private:
	void initDriversMap();
	
	QList<Compiler::ModemDriver> m_drivers;
	QString m_driverName;
	Result  m_result;
};

#endif /*COMPILERTHREAD_H_*/
