#ifndef CONNECTTHREAD_H_
#define CONNECTTHREAD_H_

#include <QThread>
#include <QByteArray>
#include <QString>
#include <QSettings>
#include <QObject>
#include <QStringList>
#include <QNetworkInterface>
#include <QProcess>
#include <QTimer>
#include <QEventLoop>

#include "Global.h"

#include "libubudsl/Globals.h"
#include "libubudsl/MyProcess.h"
#include "libubudsl/SystemInfo.h"

//extern int getModemState();

class ConnectThread: public QThread
{
	Q_OBJECT
public:
	ConnectThread(QSettings *settings, int (*fGetModemState)());
	virtual ~ConnectThread();
	
	void setModemState(int state);
	void setArguments(const QStringList &arguments) { m_arguments = arguments; }
	ReturnState::ReturnState getReturnState();
	
	MyProcess *pppd;
	
public slots:
	void run();
	
private slots:
	bool waitForSynchronization();
	
private:
	int (*getModemState)();
	
	void prepareDSL0();
	void prepareNAS0();
	void prepareBridging();
	
	QStringList m_arguments;
	QStringList m_env;
	QSettings  *m_settings;
	int         m_modemState;
	ReturnState::ReturnState m_returnState;
		
signals:
	void threadMessage(const QString &message);
	void debugMsg(QByteArray ba);
	void synchronizing();
};

#endif /*CONNECTTHREAD_H_*/
