#include "RestartModem.h"

RestartModem::RestartModem(QSettings *settings, QObject *parent)
: QThread(parent),
  m_settings(settings),
  m_restartProcess(new QProcess(0))
{
	m_restartProcess->moveToThread(this);
}

RestartModem::~RestartModem()
{
	delete m_restartProcess;
}

void RestartModem::run()
{
	m_settings->sync();
	
	const int vendor_id = m_settings->value("vendor_id", 0).toInt();
	
	if ( vendor_id == 0 )
		return;
	
	QString driver;
	
	if ( vendor_id == 0x1110 ) //ueagle-atm
	{
		driver = "ueagle-atm";
	}
	else if ( vendor_id == 0x06b9 ) //speedtch
	{
		driver = "speedtch";
	}
	else if ( vendor_id == 0x0483 ) //unicorn
	{
		driver = "unicorn_usb_eth";
	}
	else //cxacru
	{
		driver = "cxacru";
	}
	
	m_restartProcess->execute("rmmod", QStringList(driver));
	m_restartProcess->execute("modprobe", QStringList(driver));
}
