#!/bin/bash

QMAKE=qmake
QMAKE_QT4=qmake-qt4

QMAKE_OUT=$($QMAKE -v|grep "^Using Qt version 4")
QMAKE_QT4_OUT=$($QMAKE_QT4 -v|grep "^Using Qt version 4")

echo "+----------------------------------------+"
echo "| Preparing UbuDSL Daemon to compilation |"
echo "+----------------------------------------+"

if [ -n "$QMAKE_OUT" ]; then
    echo "| * Generating Daemon Adaptor...         |"
    ./generate_adaptor.sh
    echo "| * Executing ${QMAKE}...                   |"
    $QMAKE "\"$@\""
elif [ -n "$QMAKE_QT4_OUT" ]; then
    echo "| * Generating Daemon Adaptor...         |"
    ./generate_adaptor.sh
    echo "| * Executing ${QMAKE_QT4}...               |"
    $QMAKE_QT4 "\"$@\""
else
    echo "Could not find qmake (Qt4)!"
    exit 1
fi


echo "+----------------------------------------+"
echo "|  Now you can run make."


